/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Le Framework de jeux JavaScript Phaser
 *
Phaser v2.0.5 - http://phaser.io - @photonstorm - (c) 2014 Photon Storm Ltd. 
https://github.com/photonstorm/phaser
http://examples.phaser.io/
 */




/**
 * Classe de gestion du jeu
 * Le moteur...
 * 
 * @param  {[type]} game [description]
 * @return {[type]}      [description]
 */
var theGame = function(game)
{
	// déclaration des variables
	spriteNumber = null;
	nNumberRandom = 0;
	bEnableButtonsChoice = true;
	bChoiceHigher = true;
	score = 0;
}


/**
 * Les méthodes
 * 
 * @type {Object}
 */
theGame.prototype =
{

	/**
	 * Création de la scène du jeu,
	 * mise en place des graphismes...
	 * 
	 * @return {[type]} [description]
	 */
  	create: function()
  	{
		nNumberRandom = this.getRandomInt(0, 9);// choix d'un nombre aléatoire

		spriteNumber = this.game.add.sprite(160, 240, "numbers");
		spriteNumber.anchor.setTo(0.5, 0.5);
		spriteNumber.frame = nNumberRandom;// choix du nombre à afficher	

		// création du bouton de jeu "supérieur"
		var bChoiceHigherButton = this.game.add.button(160, 100, "higher", this.clickedbChoiceHigher,this);
		bChoiceHigherButton.anchor.setTo(0.5,0.5);

		// création du bouton de jeu "inférieur"
		var lowerButton = this.game.add.button(160, 380 ,"lower", this.clickedLower,this);
		lowerButton.anchor.setTo(0.5, 0.5);	
	},


	/**
	 * Génère un nombre entier aléatoire entre min (inclus) et max (inclus)
	 * 
	 */
	getRandomInt : function (min, max)
	{
	    return Math.floor( Math.random() * (max - min + 1) ) + min;
	},


	/**
	 * Clic sur le bouton "supérieur"
	 * @return {[type]} [description]
	 */
	clickedbChoiceHigher: function()
	{
		bChoiceHigher = true;// clic sur nombre plus grand par le joueur
		this.tweenNumber(true);
	},


	/**
	 * Clic sur le bouton "inférieur"
	 * @return {[type]} [description]
	 */
	clickedLower: function()
	{
		bChoiceHigher = false;// clic sur nombre plus petit par le joueur
		this.tweenNumber(false);
	},


	/**
	 * Affiche le nombre avec une animation
	 * 
	 * @param  {[type]} bChoiceHigher [description]
	 * @return {[type]}               [description]
	 */
	tweenNumber: function(bChoiceHigher)
	{
		if(bEnableButtonsChoice)
		{
			bEnableButtonsChoice=false;// désactive le clic sur les boutons

			var exitTween = this.game.add.tween(spriteNumber);
			exitTween.to({x:420},500);

			exitTween.onComplete.add(this.exitNumber,this);
			exitTween.start();
	     }
	},


	/**
	 * Appel à la fin de l'affichage du nombre
	 * @return {[type]} [description]
	 */
	exitNumber: function()
	{
		spriteNumber.x = -180;
		spriteNumber.frame = this.getRandomInt(0, 9);// choix d'un nombre aléatoire

		// création de l'animation
		var enterTween = this.game.add.tween(spriteNumber);
		enterTween.to({x:160}, 1000);

		enterTween.onComplete.add(this.enterNumber,this);// à la fin de la tween, propose au joueur de choisir
		enterTween.start();// lance l'animation
	},


	/**
	 * Le joueur effectue son choix
	 * 
	 * @return {[type]} [description]
	 */
	enterNumber: function()
	{
		bEnableButtonsChoice = true;// active le clic sur les boutons

		// si le joueur s'est trompé, perdu !
		if((bChoiceHigher && spriteNumber.frame < nNumberRandom) || (!bChoiceHigher && spriteNumber.frame > nNumberRandom))
			this.game.state.start("GameOver",true,false,score);// lance l'écran perdu
		else
		{  
			score++;
			nNumberRandom = spriteNumber.frame;
		}	
	}


}